Last Comment Bug 731594 - [bidi] Reversed text on Facebook photo galleries
: [bidi] Reversed text on Facebook photo galleries
Status: RESOLVED FIXED
: rtl
Product: Core
Classification: Components
Component: Layout: Text (show other bugs)
: unspecified
: All All
: -- normal (vote)
: mozilla15
Assigned To: Simon Montagu :smontagu
:
Mentors:
: 759907 775524 (view as bug list)
Depends on: 718236 730671 CVE-2013-0771 788086
Blocks: 698706
  Show dependency treegraph
 
Reported: 2012-02-29 07:03 PST by Tomer Cohen :tomer
Modified: 2012-10-13 10:09 PDT (History)
10 users (show)
smontagu: in‑testsuite?
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
screenshot (499.85 KB, image/png)
2012-02-29 07:03 PST, Tomer Cohen :tomer
no flags Details
w-i-p (2.83 KB, patch)
2012-03-30 11:40 PDT, Simon Montagu :smontagu
roc: review+
Details | Diff | Splinter Review

Description Tomer Cohen :tomer 2012-02-29 07:03:43 PST
Created attachment 601595 [details]
screenshot

My sister was able to reproduce something very similar to bug 704837 and bug 730671, but this time on Facebook photo galleries. 

Steps to reproduce:
a. Enter a facebook page (For example PizzaHut's https://www.facebook.com/PizzaHut.Israel)
b. Click on a photo published on their wall.
c. You'll get redirected to the photo gallery with a gray background. 
d. Navigate to next/previous photo, and watch the photo description at the right side appearing reversed. 

Note: We can't place direct link to a photo, as this won't trigger the gallery viewer and instead will show the photo page (white background).


Tested with Firefox 10.0.2 on Windows 7, and Aurora Mozilla/5.0 (X11; Linux i686; rv:12.0a2) Gecko/20120228 Firefox/12.0a2. Reproduces on other Facebook pages as well. 


Please set as duplicate if you think the same issue described on one of the other bugs.
Comment 1 Jonathan Kew (:jfkthame) 2012-02-29 07:13:32 PST
Could you please test with Aurora (FF 12)? I think this is probably another example of bug 718236, in which case it should already be fixed on Aurora (and Nightly), and will be fixed in the next Beta release of FF 11.
Comment 2 Jonathan Kew (:jfkthame) 2012-02-29 07:19:54 PST
(In reply to Jonathan Kew (:jfkthame) from comment #1)
> Could you please test with Aurora (FF 12)? I think this is probably another
> example of bug 718236, in which case it should already be fixed on Aurora
> (and Nightly), and will be fixed in the next Beta release of FF 11.

Sorry, just re-read and realized that you said it occurred on Aurora as well.

How about Nightly - is the problem present there too?
Comment 3 Jonathan Kew (:jfkthame) 2012-02-29 07:49:40 PST
OK, this is very weird. I was about to comment that I couldn't reproduce the issue as shown in your screenshot - and then it happened to me. It seems to depend on whether I arrive at that picture by stepping forward or backward through the gallery. If I reach it from the _preceding_ picture, by clicking the Next (rightward) arrow, the text displays correctly; but if I go beyond it and then return there by clicking the Previous (leftward) arrow, I see the reversed text as in your screenshot.

Similar reversed text appears in some other picture comments as well, and in some cases is dependent on how I approach the picture within the set.

(Confirmed with FF 10, Aurora 12 and Nightly builds, although the exact examples that display wrong seem to vary a bit. In one case, I even saw a line of text appear correctly at first and then flip around after a fraction of a second, though I was not able to reproduce this behavior consistently.)
Comment 4 Tomer Cohen :tomer 2012-03-12 11:13:08 PDT
We are aware of user complains about this issue. I'd suggest prioritizing it. 

http://mozilla.org.il/board/viewtopic.php?f=9&t=10982
https://www.facebook.com/MozillaIsrael/posts/360399213991581
http://input.mozilla.com/he/opinion/2766178
Comment 5 Tomer Cohen :tomer 2012-03-28 07:49:29 PDT
Any chance to resolve this issue any time soon? It make it very difficult to view photo galleries using Firefox, and it reproduce every time.

If this bug is caused by non-standard code on the Facebook side, it might be good idea to ask them to fix it.
Comment 6 :Ehsan Akhgari 2012-03-28 09:25:52 PDT
I'm bisecting to figure out exactly what regressed this.
Comment 7 :Ehsan Akhgari 2012-03-28 15:30:13 PDT
The bisection is now finished:

The first bad revision is:
changeset:   79883:00b0ddf1ab96
user:        Simon Montagu <smontagu@smontagu.org>
date:        Mon Nov 07 16:26:50 2011 +0200
summary:     Test the containing frame for continuations, not the child. Bug 698706, r=roc
Comment 8 Simon Montagu :smontagu 2012-03-30 11:40:19 PDT
Created attachment 610954 [details] [diff] [review]
w-i-p

I'm going to dogfood with this for a while before asking review. Tryserver builds will be available at http://ftp.mozilla.org/pub/mozilla.org/firefox/try-builds/smontagu@mozilla.com-b621fca09303 when ready.
Comment 9 Tomer Cohen :tomer 2012-04-01 09:19:42 PDT
I think that the tryserver build is fixing well these issues.
Comment 10 Tomer Cohen :tomer 2012-04-28 13:58:48 PDT
I am on Aurora (14) and this issue still occur. Please land this fix as soon as possible as this issue affects people in the stable channel and I am hearing complains every day about Firefox lacking support in Chrome and people that wish to downgrade only because of this issue.

Is it possible to land a fix to the beta channel so people will get the fix in less than six weeks from now?
Comment 11 :Ehsan Akhgari 2012-04-28 14:07:20 PDT
As far as I can tell, we still don't have a patch here which is ready for review...
Comment 12 Simon Montagu :smontagu 2012-05-07 09:15:05 PDT
Comment on attachment 610954 [details] [diff] [review]
w-i-p

I haven't found any regressions from this.

The patch catches some more cases where we had a dangling bidi-isolated sub-paragraph which wasn't going through bidi resolution at all. It does this by checking at the end of TraverseFrames and also when creating a new sub-paragraph whether there is any text in the current subparagraph
Comment 13 Simon Montagu :smontagu 2012-05-08 09:25:33 PDT
https://hg.mozilla.org/integration/mozilla-inbound/rev/cfa3d6007436
Unfortunately with no testcase. I spent some time trying to come up with a minimized testcase for this but didn't get anywhere.
Comment 14 Ryan VanderMeulen [:RyanVM] 2012-05-08 18:42:36 PDT
https://hg.mozilla.org/mozilla-central/rev/cfa3d6007436
Comment 15 Simon Montagu :smontagu 2012-06-14 01:29:32 PDT
*** Bug 759907 has been marked as a duplicate of this bug. ***
Comment 16 Simon Montagu :smontagu 2012-07-19 12:33:25 PDT
*** Bug 775524 has been marked as a duplicate of this bug. ***
Comment 17 Guy 2012-07-20 23:34:58 PDT
is it possible to get a version to test?
Comment 18 Simon Montagu :smontagu 2012-07-24 01:12:24 PDT
(In reply to Guy from comment #17)
> is it possible to get a version to test?

http://www.mozilla.org/beta/
Comment 19 Guy 2012-08-16 07:10:47 PDT
Hi Simon,

When there is a number in the middle of the sentence, the sentence gets out of order (the words after the number gets rearranged to the beginning of the sentence).

This one occurred to me also in Facebook.com, when replying on an Event's wall.

This is what it should look like:
 תיק נוח שאפשר לשים בו 3 ליטר מים לאדם
This is the result:
ליטר מים לאדםתיק נוח שאפשר לשים בו 3
Comment 20 Simon Montagu :smontagu 2012-08-16 09:57:33 PDT
Guy, can you open a new bug report about that, with clear instructions how to reproduce the bug? It's not the same issue as this one.

Note You need to log in before you can comment on or make changes to this bug.